﻿using ProjectContainerShip.DrawningObjects;
using ProjectContainerShip;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectContainerShip.Entities;

namespace ContainerShip.Generics
{
    internal class ContainerShipCompareByColor : IComparer<DrawningShip?>
    {
        public int Compare(DrawningShip? x, DrawningShip? y)
        {
            if (x == null || x.EntityShip == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityShip == null)
                throw new ArgumentNullException(nameof(y));
            if (x.EntityShip.BodyColor.Name != y.EntityShip.BodyColor.Name)
            {
                return x.EntityShip.BodyColor.Name.CompareTo(y.EntityShip.BodyColor.Name);
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                if (x is EntityShip)
                    return -1;
                else
                    return 1;
            }
            if (x.GetType().Name == y.GetType().Name && x is EntityContainerShip)
            {
                EntityContainerShip EntityX = (EntityContainerShip)x.EntityShip;
                EntityContainerShip EntityY = (EntityContainerShip)y.EntityShip;
                if (EntityX.AdditionalColor.Name != EntityY.AdditionalColor.Name)
                {
                    return EntityX.AdditionalColor.Name.CompareTo(EntityY.AdditionalColor.Name);
                }
            }
            var speedCompare = x.EntityShip.Speed.CompareTo(y.EntityShip.Speed);
            if (speedCompare != 0)
                return speedCompare;
            return x.EntityShip.Weight.CompareTo(y.EntityShip.Weight);
        }
    }
}
